package gamelib;
import java.awt.Polygon;

public class sprite
{
  // wg. schnellerem Zugriff alles public:
  public int id,typ,x,y,z,hotx,hoty;
  public int breite,hoehe,phase=0,maxphase=1,countdown=0;
  public double vx=0.0,vy=0.0,xx,yy;
  Polygon polydata=null; // nur bei Bedarf

  public sprite(int nr,int art,int size_x,int size_y)
  { id=nr; breite=size_x; hoehe=size_y; hotx=breite/2; hoty=hoehe/2;
    y=0; z=3; vx=0; vy=0; typ=art; stoppen();
  }

  public void set_typ(int nr)   { typ=nr; }
  public void set_poly(int np,int[] xp,int[] yp)    { polydata=new Polygon(xp,yp,np); }
  public void set_speed(double v_waa,double v_senk) { vx=v_waa; vy=v_senk; }
  public void starten()                             { countdown=0; phase=0; }
  public void stoppen()                             { moveto(-2*breite,0,-1); countdown=-1; }
  public void moveto(int zx,int zy,int zz)  { x=zx; y=zy; xx=(double)x; yy=(double)y; z=zz; }

  public void move_it()
  { xx=xx+vx; yy=yy+vy; x=(int)xx; y=(int)yy;
    phase=(phase++)%maxphase;
    if (countdown>0) countdown--;
  }

// Kollisionsdetektion: -------------------------------------------------------------------------------
  public boolean in_rechteck(int px,int py) { return ((px>x) && (px<x+breite) && (py>y) && (py<y+hoehe)); }

  public boolean in_ellipse(int px,int py)
  { double dx,dy;
    boolean ret=false;
    if (in_rechteck(px,py))
    { dx=x+hotx-px; dy=(y+hoty-py)*breite/hoehe;
      dx=dx*dx; dy=dy*dy; ret=(dx+dy<breite*breite/4);
    }
    return ret;
  }

  public boolean in_polygon(int px,int py)
  { boolean drin=false;
    if (polydata!=null) drin=polydata.contains (px,py);
    return drin;
  }

}
